diff --git a/distrib/utils/sysinst/disks.c b/distrib/utils/sysinst/disks.c
index f7c41e9..be1c612 100644
--- a/distrib/utils/sysinst/disks.c
+++ b/distrib/utils/sysinst/disks.c
@@ -360,7 +360,7 @@ int
 find_disks(const char *doingwhat)
 {
 	struct disk_desc disks[MAX_DISKS];
-	menu_ent dsk_menu[nelem(disks)];
+	menu_ent dsk_menu[nelem(disks) + !partman_go];
 	struct disk_desc *disk;
 	int i;
 	int numdisks;
@@ -390,8 +390,15 @@ find_disks(const char *doingwhat)
 			dsk_menu[i].opt_flags = OPT_EXIT;
 			dsk_menu[i].opt_action = set_dsk_select;
 		}
+		if (partman_go == 0) {
+			dsk_menu[i].opt_name = "Extended partitioning"; // TODO: localize
+			dsk_menu[i].opt_menu = OPT_NOMENU;
+			dsk_menu[i].opt_flags = OPT_EXIT;
+			dsk_menu[i].opt_action = set_dsk_select;
+		}
+
 		menu_no = new_menu(MSG_Available_disks,
-			dsk_menu, numdisks, -1, 4, 0, 0,
+			dsk_menu, numdisks + !partman_go, -1, 4, 0, 0,
 			MC_SCROLL,
 			NULL, NULL, NULL, NULL, NULL);
 		if (menu_no == -1)
@@ -403,34 +410,41 @@ find_disks(const char *doingwhat)
 
 	if (selected_disk == -1)
 	    return -1;
+	if (selected_disk == numdisks) {
+		partman_go = 1;
+	    return -2;
+	}
 
 	disk = disks + selected_disk;
-	strlcpy(diskdev, disk->dd_name, sizeof diskdev);
+	pm = pm_found;
+	pm->bootable = 0;
+	strlcpy(pm->diskdev, disk->dd_name, sizeof pm->diskdev);
+	strlcpy(pm->diskdev_descr, disk->dd_descr, sizeof pm->diskdev_descr);
 
 	/* Use as a default disk if the user has the sets on a local disk */
-	strlcpy(localfs_dev, disk->dd_name, sizeof localfs_dev);
-
-	sectorsize = disk->dd_secsize;
-	dlcyl = disk->dd_cyl;
-	dlhead = disk->dd_head;
-	dlsec = disk->dd_sec;
-	dlsize = disk->dd_totsec;
-	no_mbr = disk->dd_no_mbr;
-	if (dlsize == 0)
-		dlsize = disk->dd_cyl * disk->dd_head * disk->dd_sec;
-	if (dlsize > UINT32_MAX) {
+	strlcpy(localfs_dev, disk->dd_name, sizeof localfs_dev); // TODO: sss
+
+	pm->sectorsize = disk->dd_secsize;
+	pm->dlcyl = disk->dd_cyl;
+	pm->dlhead = disk->dd_head;
+	pm->dlsec = disk->dd_sec;
+	pm->dlsize = disk->dd_totsec;
+	pm->no_mbr = disk->dd_no_mbr;
+	if (pm->dlsize == 0)
+		pm->dlsize = disk->dd_cyl * disk->dd_head * disk->dd_sec;
+	if (pm->dlsize > UINT32_MAX) {
 		msg_display(MSG_toobigdisklabel);
 		process_menu(MENU_ok, NULL);
 		return -1;
 	}
-	dlcylsize = dlhead * dlsec;
+	pm->dlcylsize = pm->dlhead * pm->dlsec;
 
 	/* Get existing/default label */
-	memset(&oldlabel, 0, sizeof oldlabel);
-	incorelabel(diskdev, oldlabel);
+	memset(&pm->oldlabel, 0, sizeof pm->oldlabel);
+	incorelabel(pm->diskdev, pm->oldlabel);
 
 	/* Set 'target' label to current label in case we don't change it */
-	memcpy(&bsdlabel, &oldlabel, sizeof bsdlabel);
+	memcpy(&pm->bsdlabel, &pm->oldlabel, sizeof pm->bsdlabel);
 
 	return numdisks;
 }
@@ -441,7 +455,7 @@ fmt_fspart(menudesc *m, int ptn, void *arg)
 	unsigned int poffset, psize, pend;
 	const char *desc;
 	static const char *Yes, *No;
-	partinfo *p = bsdlabel + ptn;
+	partinfo *p = pm->bsdlabel + ptn;
 
 	if (Yes == NULL) {
 		Yes = msg_string(MSG_Yes);
@@ -499,7 +513,7 @@ write_disklabel (void)
 #ifdef DISKLABEL_CMD
 	/* disklabel the disk */
 	return run_program(RUN_DISPLAY, "%s -f /tmp/disktab %s '%s'",
-	    DISKLABEL_CMD, diskdev, bsddiskname);
+	    DISKLABEL_CMD, pm->diskdev, pm->bsddiskname);
 #else
 	return 0;
 #endif
@@ -509,8 +523,8 @@ write_disklabel (void)
 static int
 ptn_sort(const void *a, const void *b)
 {
-	return strcmp(bsdlabel[*(const int *)a].pi_mount,
-		      bsdlabel[*(const int *)b].pi_mount);
+	return strcmp(pm->bsdlabel[*(const int *)a].pi_mount,
+		      pm->bsdlabel[*(const int *)b].pi_mount);
 }
 
 int
@@ -518,16 +532,14 @@ make_filesystems(void)
 {
 	unsigned int i;
 	int ptn;
-	int ptn_order[nelem(bsdlabel)];
+	int ptn_order[nelem(pm->bsdlabel)];
 	int error = 0;
 	unsigned int maxpart = getmaxpartitions();
 	char *newfs;
-	const char *mnt_opts;
-	const char *fsname;
 	partinfo *lbl;
 
-	if (maxpart > nelem(bsdlabel))
-		maxpart = nelem(bsdlabel);
+	if (maxpart > nelem(pm->bsdlabel))
+		maxpart = nelem(pm->bsdlabel);
 
 	/* Making new file systems and mounting them */
 
@@ -543,9 +555,9 @@ make_filesystems(void)
 		 * point defined, or is marked preserve, don't touch it!
 		 */
 		ptn = ptn_order[i];
-		lbl = bsdlabel + ptn;
+		lbl = pm->bsdlabel + ptn;
 
-		if (is_active_rootpart(diskdev, ptn))
+		if (is_active_rootpart(pm->diskdev, ptn))
 			continue;
 
 		if (*lbl->pi_mount == 0)
@@ -553,14 +565,14 @@ make_filesystems(void)
 			continue;
 
 		newfs = NULL;
-		mnt_opts = NULL;
-		fsname = NULL;
+		lbl->mnt_opts = NULL;
+		lbl->fsname = NULL;
 		switch (lbl->pi_fstype) {
 		case FS_APPLEUFS:
 			asprintf(&newfs, "/sbin/newfs %s%.0d",
 				lbl->pi_isize != 0 ? "-i" : "", lbl->pi_isize);
-			mnt_opts = "-tffs -o async";
-			fsname = "ffs";
+			lbl->mnt_opts = "-tffs -o async";
+			lbl->fsname = "ffs";
 			break;
 		case FS_BSDFFS:
 			asprintf(&newfs,
@@ -569,36 +581,36 @@ make_filesystems(void)
 			    lbl->pi_fsize * lbl->pi_frag, lbl->pi_fsize,
 			    lbl->pi_isize != 0 ? " -i " : "", lbl->pi_isize);
 			if (lbl->pi_flags & PIF_LOG)
-				mnt_opts = "-tffs -o log";
+				lbl->mnt_opts = "-tffs -o log";
 			else
-				mnt_opts = "-tffs -o async";
-			fsname = "ffs";
+				lbl->mnt_opts = "-tffs -o async";
+			lbl->fsname = "ffs";
 			break;
 		case FS_BSDLFS:
 			asprintf(&newfs, "/sbin/newfs_lfs -b %d",
 				lbl->pi_fsize * lbl->pi_frag);
-			mnt_opts = "-tlfs";
-			fsname = "lfs";
+			lbl->mnt_opts = "-tlfs";
+			lbl->fsname = "lfs";
 			break;
 		case FS_MSDOS:
 #ifdef USE_NEWFS_MSDOS
 			asprintf(&newfs, "/sbin/newfs_msdos");
 #endif
-			mnt_opts = "-tmsdos";
-			fsname = "msdos";
+			lbl->mnt_opts = "-tmsdos";
+			lbl->fsname = "msdos";
 			break;
 #ifdef USE_SYSVBFS
 		case FS_SYSVBFS:
 			asprintf(&newfs, "/sbin/newfs_sysvbfs");
-			mnt_opts = "-tsysvbfs";
-			fsname = "sysvbfs";
+			lbl->mnt_opts = "-tsysvbfs";
+			lbl->fsname = "sysvbfs";
 			break;
 #endif
 #ifdef USE_EXT2FS
 		case FS_EX2FS:
 			asprintf(&newfs, "/sbin/newfs_ext2fs");
-			mnt_opts = "-text2fs";
-			fsname = "ext2fs";
+			lbl->mnt_opts = "-text2fs";
+			lbl->fsname = "ext2fs";
 			break;
 #endif
 		}
@@ -608,11 +620,11 @@ make_filesystems(void)
 			        /* newfs only if mount fails */
 			        if (run_program(RUN_SILENT | RUN_ERROR_OK,
 				    "mount -rt msdos /dev/%s%c /mnt2",
-				    diskdev, 'a' + ptn) != 0)
+				    pm->diskdev, 'a' + ptn) != 0)
 					error = run_program(
 					    RUN_DISPLAY | RUN_PROGRESS,
 					    "%s /dev/r%s%c",
-					    newfs, diskdev, 'a' + ptn);
+					    newfs, pm->diskdev, 'a' + ptn);
 				else {
 			        	run_program(RUN_SILENT | RUN_ERROR_OK,
 					    "umount /mnt2");
@@ -621,10 +633,10 @@ make_filesystems(void)
 			} else
 #endif
 			error = run_program(RUN_DISPLAY | RUN_PROGRESS,
-			    "%s /dev/r%s%c", newfs, diskdev, 'a' + ptn);
+			    "%s /dev/r%s%c", newfs, pm->diskdev, 'a' + ptn);
 		} else {
 			/* We'd better check it isn't dirty */
-			error = fsck_preen(diskdev, ptn, fsname);
+			error = fsck_preen(pm->diskdev, ptn, lbl->fsname);
 		}
 		free(newfs);
 		if (error != 0)
@@ -632,13 +644,14 @@ make_filesystems(void)
 
 		md_pre_mount();
 
-		if (lbl->pi_flags & PIF_MOUNT && mnt_opts != NULL) {
+		if (partman_go == 0 && lbl->pi_flags & PIF_MOUNT &&
+				lbl->mnt_opts != NULL) {
 			make_target_dir(lbl->pi_mount);
-			error = target_mount(mnt_opts, diskdev, ptn,
+			error = target_mount(lbl->mnt_opts, pm->diskdev, ptn,
 					    lbl->pi_mount);
 			if (error) {
 				msg_display(MSG_mountfail,
-					    diskdev, 'a' + ptn, lbl->pi_mount);
+					    pm->diskdev, 'a' + ptn, lbl->pi_mount);
 				process_menu(MENU_ok, NULL);
 				return error;
 			}
@@ -655,30 +668,35 @@ make_fstab(void)
 	const char *dump_dev;
 
 	/* Create the fstab. */
-	make_target_dir("/etc");
-	f = target_fopen("/etc/fstab", "w");
+	if (fstab_prepared == 0) {
+		make_target_dir("/etc");
+		f = target_fopen("/etc/fstab", "w");
+		scripting_fprintf(NULL, "cat <<EOF >%s/etc/fstab\n", target_prefix());
+	} else {
+		f = target_fopen("/etc/fstab", "a");
+		scripting_fprintf(NULL, "cat <<EOF >>%s/etc/fstab\n", target_prefix());
+	}
 	if (logfp)
 		(void)fprintf(logfp,
-		    "Creating %s/etc/fstab.\n", target_prefix());
-	scripting_fprintf(NULL, "cat <<EOF >%s/etc/fstab\n", target_prefix());
-
+		    "Making %s/etc/fstab (%s).\n", target_prefix(), pm->diskdev);
+	
 	if (f == NULL) {
-#ifndef DEBUG
 		msg_display(MSG_createfstab);
 		if (logfp)
 			(void)fprintf(logfp, "Failed to make /etc/fstab!\n");
 		process_menu(MENU_ok, NULL);
+#ifndef DEBUG
 		return 1;
 #else
 		f = stdout;
 #endif
 	}
-
-	scripting_fprintf(f, "# NetBSD %s/etc/fstab\n# See /usr/share/examples/"
-		"fstab/ for more examples.\n", target_prefix());
+	if (!fstab_prepared)
+		scripting_fprintf(f, "# NetBSD %s/etc/fstab\n# See /usr/share/examples/"
+			"fstab/ for more examples.\n", target_prefix());
 	for (i = 0; i < getmaxpartitions(); i++) {
 		const char *s = "";
-		const char *mp = bsdlabel[i].pi_mount;
+		const char *mp = pm->bsdlabel[i].pi_mount;
 		const char *fstype = "ffs";
 		int fsck_pass = 0, dump_freq = 0;
 
@@ -691,7 +709,7 @@ make_fstab(void)
 			mp = "/mnt";
 		}
 
-		switch (bsdlabel[i].pi_fstype) {
+		switch (pm->bsdlabel[i].pi_fstype) {
 		case FS_UNUSED:
 			continue;
 		case FS_BSDLFS:
@@ -718,7 +736,7 @@ make_fstab(void)
 				dump_dev ="";
 			}
 			scripting_fprintf(f, "/dev/%s%c\t\tnone\tswap\tsw%s\t\t 0 0\n",
-				diskdev, 'a' + i, dump_dev);
+				pm->diskdev, 'a' + i, dump_dev);
 			continue;
 #ifdef USE_SYSVBFS
 		case FS_SYSVBFS:
@@ -732,52 +750,53 @@ make_fstab(void)
 			break;
 		}
 		/* The code that remounts root rw doesn't check the partition */
-		if (strcmp(mp, "/") == 0 && !(bsdlabel[i].pi_flags & PIF_MOUNT))
+		if (strcmp(mp, "/") == 0 && !(pm->bsdlabel[i].pi_flags & PIF_MOUNT))
 			s = "# ";
 
  		scripting_fprintf(f,
 		  "%s/dev/%s%c\t\t%s\t%s\trw%s%s%s%s%s%s%s%s\t\t %d %d\n",
-		   s, diskdev, 'a' + i, mp, fstype,
-		   bsdlabel[i].pi_flags & PIF_LOG ? ",log" : "",
-		   bsdlabel[i].pi_flags & PIF_MOUNT ? "" : ",noauto",
-		   bsdlabel[i].pi_flags & PIF_ASYNC ? ",async" : "",
-		   bsdlabel[i].pi_flags & PIF_NOATIME ? ",noatime" : "",
-		   bsdlabel[i].pi_flags & PIF_NODEV ? ",nodev" : "",
-		   bsdlabel[i].pi_flags & PIF_NODEVMTIME ? ",nodevmtime" : "",
-		   bsdlabel[i].pi_flags & PIF_NOEXEC ? ",noexec" : "",
-		   bsdlabel[i].pi_flags & PIF_NOSUID ? ",nosuid" : "",
+		   s, pm->diskdev, 'a' + i, mp, fstype,
+		   pm->bsdlabel[i].pi_flags & PIF_LOG ? ",log" : "",
+		   pm->bsdlabel[i].pi_flags & PIF_MOUNT ? "" : ",noauto",
+		   pm->bsdlabel[i].pi_flags & PIF_ASYNC ? ",async" : "",
+		   pm->bsdlabel[i].pi_flags & PIF_NOATIME ? ",noatime" : "",
+		   pm->bsdlabel[i].pi_flags & PIF_NODEV ? ",nodev" : "",
+		   pm->bsdlabel[i].pi_flags & PIF_NODEVMTIME ? ",nodevmtime" : "",
+		   pm->bsdlabel[i].pi_flags & PIF_NOEXEC ? ",noexec" : "",
+		   pm->bsdlabel[i].pi_flags & PIF_NOSUID ? ",nosuid" : "",
 		   dump_freq, fsck_pass);
 	}
-
-	if (tmp_ramdisk_size != 0) {
+	if (!fstab_prepared) {
+		if (tmp_ramdisk_size != 0) {
 #ifdef HAVE_TMPFS
-		scripting_fprintf(f, "tmpfs\t\t/tmp\ttmpfs\trw,-m=1777,-s=%"
-		    PRIi64 "\n",
-		    tmp_ramdisk_size * 512);
-#else
-		if (swap_dev != -1)
-			scripting_fprintf(f, "/dev/%s%c\t\t/tmp\tmfs\trw,-s=%"
+			scripting_fprintf(f, "tmpfs\t\t/tmp\ttmpfs\trw,-m=1777,-s=%"
 			    PRIi64 "\n",
-			    diskdev, 'a' + swap_dev, tmp_ramdisk_size);
-		else
-			scripting_fprintf(f, "swap\t\t/tmp\tmfs\trw,-s=%"
-			    PRIi64 "\n",
-			    tmp_ramdisk_size);
+			    tmp_ramdisk_size * 512);
+#else
+			if (swap_dev != -1)
+				scripting_fprintf(f, "/dev/%s%c\t\t/tmp\tmfs\trw,-s=%"
+				    PRIi64 "\n",
+				    pm->diskdev, 'a' + swap_dev, tmp_ramdisk_size);
+			else
+				scripting_fprintf(f, "swap\t\t/tmp\tmfs\trw,-s=%"
+				    PRIi64 "\n",
+				    tmp_ramdisk_size);
 #endif
-	}
-
-	/* Add /kern, /proc and /dev/pts to fstab and make mountpoint. */
-	scripting_fprintf(f, "kernfs\t\t/kern\tkernfs\trw\n");
-	scripting_fprintf(f, "ptyfs\t\t/dev/pts\tptyfs\trw\n");
-	scripting_fprintf(f, "procfs\t\t/proc\tprocfs\trw\n");
-	scripting_fprintf(f, "/dev/" CD_NAME "\t\t/cdrom\tcd9660\tro,noauto\n");
-	make_target_dir("/kern");
-	make_target_dir("/proc");
-	make_target_dir("/dev/pts");
-	make_target_dir("/cdrom");
+		}
 
+		/* Add /kern, /proc and /dev/pts to fstab and make mountpoint. */
+		scripting_fprintf(f, "kernfs\t\t/kern\tkernfs\trw\n");
+		scripting_fprintf(f, "ptyfs\t\t/dev/pts\tptyfs\trw\n");
+		scripting_fprintf(f, "procfs\t\t/proc\tprocfs\trw\n");
+		scripting_fprintf(f, "/dev/" CD_NAME "\t\t/cdrom\tcd9660\tro,noauto\n");
+		make_target_dir("/kern");
+		make_target_dir("/proc");
+		make_target_dir("/dev/pts");
+		make_target_dir("/cdrom");
+	}
 	scripting_fprintf(NULL, "EOF\n");
 
+	fstab_prepared = 1;
 #ifndef DEBUG
 	fclose(f);
 	fflush(NULL);
@@ -919,7 +938,7 @@ mount_root(void)
 {
 	int	error;
 
-	error = fsck_preen(diskdev, rootpart, "ffs");
+	error = fsck_preen(pm->diskdev, rootpart, "ffs");
 	if (error != 0)
 		return error;
 
@@ -931,7 +950,7 @@ mount_root(void)
 	 * XXX consider -o remount in case target root is
 	 * current root, still readonly from single-user?
 	 */
-	return target_mount("", diskdev, rootpart, "");
+	return target_mount("", pm->diskdev, rootpart, "");
 }
 
 /* Get information on the file systems mounted from the root filesystem.
@@ -969,7 +988,7 @@ mount_disks(void)
 	/* Check the target /etc/fstab exists before trying to parse it. */
 	if (target_dir_exists_p("/etc") == 0 ||
 	    target_file_exists_p("/etc/fstab") == 0) {
-		msg_display(MSG_noetcfstab, diskdev);
+		msg_display(MSG_noetcfstab, pm->diskdev);
 		process_menu(MENU_ok, NULL);
 		return 0;
 	}
@@ -979,7 +998,7 @@ mount_disks(void)
 	fstabsize = target_collect_file(T_FILE, &fstab, "/etc/fstab");
 	if (fstabsize < 0) {
 		/* error ! */
-		msg_display(MSG_badetcfstab, diskdev);
+		msg_display(MSG_badetcfstab, pm->diskdev);
 		process_menu(MENU_ok, NULL);
 		return 0;
 	}
@@ -997,7 +1016,7 @@ set_swap(const char *disk, partinfo *pp)
 	int rval;
 
 	if (pp == NULL)
-		pp = oldlabel;
+		pp = pm->oldlabel;
 
 	for (i = 0; i < MAXPARTITIONS; i++) {
 		if (pp[i].pi_fstype != FS_SWAP)
@@ -1073,11 +1092,11 @@ bootxx_name(void)
 	char *bootxx;
 
 	/* check we have boot code for the root partition type */
-	fstype = bsdlabel[rootpart].pi_fstype;
+	fstype = pm->bsdlabel[rootpart].pi_fstype;
 	switch (fstype) {
 #if defined(BOOTXX_FFSV1) || defined(BOOTXX_FFSV2)
 	case FS_BSDFFS:
-		if (bsdlabel[rootpart].pi_flags & PIF_FFSv2) {
+		if (pm->bsdlabel[rootpart].pi_flags & PIF_FFSv2) {
 #ifdef BOOTXX_FFSV2
 			bootxxname = BOOTXX_FFSV2;
 #else
@@ -1110,55 +1129,288 @@ bootxx_name(void)
 }
 #endif
 
-// TODO: write new partition tool there
+
+
+
+void
+partman_select(pm_devs_t *pm_devs_in)
+{
+	pm = pm_devs_in;
+	if (logfp)
+		(void)fprintf(logfp,"Partman device: %s\n", pm->diskdev);
+	return;
+
+}
+
+// TODO: mount order
+static int
+partman_mountall_sort(const void *a, const void *b)
+{
+	return strcmp(mnts[*(const int *)a].pi_mount,
+		      mnts[*(const int *)b].pi_mount);
+}
+
 int
-partitioning(void)
+partman_mountall(void)
 {
+	pm_devs_t *pm_devs_i;
+	int num_devs = 0;
+	int i, error;
+
+	int mnts_order[MNTS_MAX]; // TODO: rewrite
+	for (pm_devs_i = pm_devs->next, num_devs = 0; pm_devs_i != NULL;
+			pm_devs_i = pm_devs_i->next) {
+		fprintf(logfp,"::%s\n",pm_devs_i->diskdev); fflush(logfp);
+		for (i = 0; i < MAXPARTITIONS; i++) {
+			if (pm_devs_i->bsdlabel[i].pi_flags & PIF_MOUNT &&
+					pm_devs_i->bsdlabel[i].mnt_opts != NULL) {
+				mnts[num_devs].diskdev = pm_devs_i->diskdev;
+				mnts[num_devs].mnt_opts = pm_devs_i->bsdlabel[i].mnt_opts;
+				mnts[num_devs].fsname = pm_devs_i->bsdlabel[i].fsname;
+				mnts[num_devs].pi_mount = pm_devs_i->bsdlabel[i].pi_mount;
+				num_devs++;
+				fprintf(logfp,":::%s\n",mnts[num_devs].pi_mount); fflush(logfp);
+			}
+		}
+	}
+	for (i = 0; i < num_devs; i++)
+		mnts_order[i] = i;
+	qsort(mnts_order, num_devs, sizeof mnts_order[0], partman_mountall_sort);
+
+	for (i = 0; i < num_devs; i++) {
+		make_target_dir(mnts[i].pi_mount);
+		error = target_mount(mnts[i].mnt_opts, pm->diskdev, i, mnts[i].pi_mount);
+		if (error) {
+			msg_display(MSG_mountfail, pm->diskdev, 'a' + i, mnts[i].pi_mount);
+			process_menu(MENU_ok, NULL);
+			return error;
+		}
+	}
+	return 0;
+}
+
+int
+partman_adddisk(menudesc *m, void *arg)
+{
+	*(int *)arg = m->cursel + 1;
+	pm_devs_t *pm_devs_tmp;
+
 	if (find_disks(msg_string(MSG_install)) < 0)
 		return -1;
+
 	clear();
 	refresh();
 
-	if (check_swap(diskdev, 0) > 0) {
+	if (check_swap(pm->diskdev, 0) > 0) {
 		msg_display(MSG_swapactive);
 		process_menu(MENU_ok, NULL);
-		if (check_swap(diskdev, 1) < 0) {
+		if (check_swap(pm->diskdev, 1) < 0) {
 			msg_display(MSG_swapdelfailed);
 			process_menu(MENU_ok, NULL);
-			if (!debug)
-				return -1;
+			return -1;
 		}
 	}
 
-	if (md_get_info() == 0)
-		return -1;
-	if (md_make_bsd_partitions() == 0)
-		return -1;
+	for (pm_devs_tmp = pm_devs; pm_devs_tmp->next != NULL;
+			pm_devs_tmp = pm_devs_tmp->next)
+		if (strcmp(pm_devs_tmp->next->diskdev, pm->diskdev) == 0)
+			return 0;
+	pm_devs_tmp->next = pm_found;
 
-	/* Last chance ... do you really want to do this? */
-	clear();
-	refresh();
-	msg_display(MSG_lastchance, diskdev);
-	process_menu(MENU_noyes, NULL);
-	if (!yesno)
-		return -1;
+	pm_found = malloc(sizeof (pm_devs_t));
+	pm_found->next = NULL;
 
-	if (md_pre_disklabel() != 0)
-		return -1;
+	return 0;
+}
 
-	if (write_disklabel() != 0)
-		return -1;
+int
+partman_addvnd(menudesc *m, void *arg)
+{
+	*(int *)arg = m->cursel + 1;
+	return 0;
+}
 
-	if (md_post_disklabel() != 0)
-		return -1;
+int
+partman_deldev(menudesc *m, void *arg)
+{
+	pm_devs_t *pm_devs_tmp, *pm_devs_swap;
+	*(int *)arg = m->cursel + 1;
+
+	for (pm_devs_tmp = pm_devs; pm_devs_tmp->next != NULL;
+			pm_devs_tmp = pm_devs_tmp->next)
+		if (pm_devs_tmp->next == pm) {
+			if (pm_devs_tmp->next->next == NULL) {
+				free(pm_devs_tmp->next);
+				pm_devs_tmp->next = NULL;
+			} else {
+				pm_devs_swap = pm_devs_tmp->next->next;
+				free(pm_devs_tmp->next);
+				pm_devs_tmp->next = pm_devs_swap;
+			}
+			return 0;
+		}
+	return -1;
+}
 
-	if (make_filesystems())
-		return -1;
+int
+partman_commit(menudesc *m, void *arg)
+{
+	pm_devs_t *pm_devs_i;
+	*(int *)arg = m->cursel + 1;
+
+	for (pm_devs_i = pm_devs->next; pm_devs_i != NULL;
+			pm_devs_i = pm_devs_i->next) {
+		partman_select(pm_devs_i);
+		if (
+				md_pre_disklabel() != 0  || /* Write partition table */
+				write_disklabel() != 0   || /* Write slices table (disklabel) */
+				md_post_disklabel() != 0 || /* Enable swap and check badblock */
+				make_filesystems()          /* Create filesystems by newfs */
+			) { /* If something fails... */
+			return -1;
+		}
+		/* Write bootsector if needed */
+		if (pm_devs_i->bootable && md_post_newfs() != 0) {
+			return -1;
+		}
+	}
+    return 0;
+}
 
-	if (make_fstab() != 0)
+static int
+partman_submenu(menudesc *m, void *arg)
+{
+	pm_devs_t *pm_devs_i;
+	int retvalue;
+	int ok = 0;
+	int i;
+	*(int *)arg = m->cursel + 1;
+
+	/* write selected disk to diskdev variable */
+	for (pm_devs_i = pm_devs->next, i = 0; !ok && pm_devs_i != NULL;
+			pm_devs_i = pm_devs_i->next, i++)
+		if (i == m->cursel) {
+			partman_select(pm_devs_i);
+			ok = 1;
+			break;
+		}
+	if (!ok)
 		return -1;
 
-	if (md_post_newfs() != 0)
-		return -1;
-    return 0;
+	process_menu(MENU_pmentry, &retvalue);
+	return 0;
+}
+
+void
+partman_menufmt(menudesc *m, int ptn, void *arg)
+{
+	pm_devs_t *pm_devs_i;
+	int i;
+	unsigned int maxpart;
+	char *dev_mounts = malloc(STRSIZE * sizeof(char));
+	dev_mounts[0] = '\0';
+
+	for (pm_devs_i = pm_devs->next, i = 0;
+			i != ptn && pm_devs_i != NULL;
+			pm_devs_i = pm_devs_i->next, i++);
+	if (i != ptn || pm_devs_i == NULL) 
+		return;
+
+	maxpart = ((unsigned int)getmaxpartitions() > nelem(pm_devs_i->bsdlabel))?
+				nelem(pm_devs_i->bsdlabel) : (unsigned int)getmaxpartitions();
+	for (i = 0; (unsigned int)i < maxpart; i++) {
+		if (pm_devs_i->bsdlabel[i].pi_mount != 0 &&
+				pm_devs_i->bsdlabel[i].pi_fstype != FS_UNUSED) {
+			strcat(dev_mounts, pm_devs_i->bsdlabel[i].pi_mount);
+			strcat(dev_mounts, " ");
+		}
+	}
+
+	wprintw(m->mw,"%-25s %-20s %4s", pm_devs_i->diskdev_descr, dev_mounts,
+			(pm_devs_i->bootable)?"BOOT":"" );
+	return;
+}
+
+// TODO: switch to langfiles
+// TODO: resolve case with 2 same bsddisknames
+int
+partman(void)
+{
+	menu_ent part_menu[MAX_DISKS];
+	int menu_pm;
+	int i, ii;
+	int retvalue = 0;
+	pm_devs_t *pm_devs_i;
+
+	do {
+		clear();
+		refresh();
+		for (pm_devs_i = pm_devs->next, i = 0; pm_devs_i != NULL;
+				pm_devs_i = pm_devs_i->next, i++) {
+			part_menu[i].opt_name = NULL;
+			part_menu[i].opt_action = partman_submenu;
+		}
+
+		part_menu[i] = (struct menu_ent) {
+			.opt_name = "Add disk",
+			.opt_action = partman_adddisk,
+		};
+		part_menu[++i] = (struct menu_ent) {
+			.opt_name = "Create CGD",
+			.opt_action = partman_addvnd,
+		};
+		part_menu[++i] = (struct menu_ent) {
+			.opt_name = "Create VND disk",
+			.opt_action = partman_addvnd,
+		};
+		part_menu[++i] = (struct menu_ent) {
+			.opt_name = "Create LVM VG",
+			.opt_action = partman_addvnd,
+		};
+		part_menu[++i] = (struct menu_ent) {
+			.opt_name = "Create RAIFframe",
+			.opt_action = partman_addvnd,
+		};
+		part_menu[++i] = (struct menu_ent) {
+			.opt_name = "Commit changes",
+			.opt_action = partman_commit,
+		};
+
+		for (ii = 0; ii <= i; ii++) {
+			part_menu[ii].opt_menu = OPT_NOMENU;
+			part_menu[ii].opt_flags = OPT_EXIT;
+		}
+
+		menu_pm = new_menu("Disk editor. All disks, partitions, LVM, RAID displayed there.\nAt first add drive, then prepare partitions and go.",
+			part_menu, i+1,	1, 1, 0, 0, MC_ALWAYS_SCROLL | MC_NOBOX | MC_NOCLEAR,
+			NULL, partman_menufmt, NULL, NULL, NULL);
+		retvalue = 0;
+		if (menu_pm == -1)
+			retvalue = -1;
+		else {
+			process_menu(menu_pm, &retvalue);
+			free_menu(menu_pm);
+		}
+
+		if (logfp)
+			(void)fprintf(logfp, "partman retvalue is %d\n", retvalue);
+	} while (retvalue > 0);
+	
+	// TODO: check_partitions()
+	/* Check that fstab on target device is readable - if so then we can go */
+	if (retvalue == 0) {
+		if (partman_mountall() != 0 ||
+			make_fstab() != 0)
+			retvalue = -1;
+		else {
+			FILE *file_tmp = fopen(concat_paths(targetroot_mnt, "/etc/fstab"), "r");
+			if (file_tmp == NULL)
+				retvalue = -1;
+			else
+				fclose(file_tmp);
+		}
+	}
+
+	/* retvalue <0 - error, retvalue ==0 - user quits, retvalue >0 - all ok */
+	return (retvalue >= 0)?0:-1;
 }
diff --git a/distrib/utils/sysinst/install.c b/distrib/utils/sysinst/install.c
index 077c75a..10935e3 100644
--- a/distrib/utils/sysinst/install.c
+++ b/distrib/utils/sysinst/install.c
@@ -45,23 +45,70 @@
 void
 do_install(void)
 {
+	int find_disks_ret;
+	int retcode = 0;
+	partman_go = 0;
+	fstab_prepared = 0;
 
+#ifndef DEBUG
 	msg_display(MSG_installusure);
 	process_menu(MENU_noyes, NULL);
 	if (!yesno)
 		return;
+#endif
 
 	get_ramsize();
 
 	/* Create and mount partitions */
-	if (!partitioning() < 0) {
-		msg_display(MSG_abort);
-		process_menu(MENU_ok, NULL);
+	find_disks_ret = find_disks(msg_string(MSG_install));
+	if (partman_go == 1) {
+		if (partman() < 0) {
+			msg_display(MSG_abort);
+			process_menu(MENU_ok, NULL);
+			return;
+		}		
+	} else if (find_disks_ret < 0)
 		return;
+	else {
+	/* Classical partitioning wizard */
+		clear();
+		refresh();
+
+		if (check_swap(pm->diskdev, 0) > 0) {
+			msg_display(MSG_swapactive);
+			process_menu(MENU_ok, NULL);
+			if (check_swap(pm->diskdev, 1) < 0) {
+				msg_display(MSG_swapdelfailed);
+				process_menu(MENU_ok, NULL);
+				if (!debug)
+					return;
+			}
+		}
+
+		if (!md_get_info() || md_make_bsd_partitions() == 0) {
+			msg_display(MSG_abort);
+			process_menu(MENU_ok, NULL);
+			return;
+		}
+
+		/* Last chance ... do you really want to do this? */
+		clear();
+		refresh();
+		msg_display(MSG_lastchance, pm->diskdev);
+		process_menu(MENU_noyes, NULL);
+		if (!yesno)
+			return;
+
+		if (md_pre_disklabel() != 0 || write_disklabel() != 0 ||
+			md_post_disklabel() != 0 ||make_filesystems() ||
+			make_fstab() != 0 || md_post_newfs() != 0)
+			return;
 	}
 
 	/* Unpack the distribution. */
-	process_menu(MENU_distset, NULL);
+	process_menu(MENU_distset, &retcode);
+	if (retcode == 0)
+		return;
 	if (get_and_unpack_sets(0, MSG_disksetupdone,
 	    MSG_extractcomplete, MSG_abortinst) != 0)
 		return;
diff --git a/distrib/utils/sysinst/label.c b/distrib/utils/sysinst/label.c
index f6d96ae..ebdb567 100644
--- a/distrib/utils/sysinst/label.c
+++ b/distrib/utils/sysinst/label.c
@@ -193,7 +193,7 @@ edit_fs_size(menudesc *m, void *arg)
 
 	size = getpartsize(p->pi_offset, p->pi_size);
 	if (size == ~0u)
-		size = dlsize - p->pi_offset;
+		size = pm->dlsize - p->pi_offset;
 	p->pi_size = size;
 	if (size == 0) {
 		p->pi_offset = 0;
@@ -398,7 +398,7 @@ edit_ptn(menudesc *menu, void *arg)
 			get_fstype, NULL, NULL, NULL, MSG_unchanged);
 	}
 
-	p = bsdlabel + menu->cursel;
+	p = pm->bsdlabel + menu->cursel;
 	p->pi_flags &= ~PIF_RESET;
 	p_save = *p;
 	for (;;) {
@@ -419,7 +419,7 @@ set_ptn_header(menudesc *m, void *arg)
 	int t;
 
 	msg_clear();
-	msg_table_add(MSG_edfspart, 'a' + (p - bsdlabel));
+	msg_table_add(MSG_edfspart, 'a' + (p - pm->bsdlabel));
 
 	/* Determine which of the properties can be changed */
 	for (i = PTN_MENU_START; i <= PTN_MENU_MOUNTPT; i++) {
@@ -461,10 +461,10 @@ set_ptn_header(menudesc *m, void *arg)
 static void
 disp_sector_count(menudesc *m, msg fmt, uint s)
 {
-	uint ms = MEG / sectorsize;
+	uint ms = MEG / pm->sectorsize;
 
 	wprintw(m->mw, msg_string(fmt),
-		s / ms, s / dlcylsize, s % dlcylsize ? '*' : ' ', s );
+		s / ms, s / pm->dlcylsize, s % pm->dlcylsize ? '*' : ' ', s );
 }
 
 static void
@@ -575,7 +575,7 @@ set_label_texts(menudesc *menu, void *arg)
 			m->opt_flags = OPT_IGNORE;
 		} else {
 			m->opt_flags = 0;
-			if (bsdlabel[ptn].pi_fstype == FS_UNUSED)
+			if (pm->bsdlabel[ptn].pi_fstype == FS_UNUSED)
 				continue;
 		}
 		show_unused_ptn = ptn + 2;
@@ -629,7 +629,7 @@ edit_and_check_label(partinfo *lp, int nparts, int rawpart, int bsdpart)
 		return 1;
 
 	pi.flags = 0;
-	current_cylsize = dlcylsize;
+	pm->current_cylsize = pm->dlcylsize;
 
 	for (;;) {
 		int i, j;
@@ -639,7 +639,7 @@ edit_and_check_label(partinfo *lp, int nparts, int rawpart, int bsdpart)
 
 		/* User thinks the label is OK. */
 		/* check we have a single root fs */
-		if (check_one_root(lp, nparts) == 0)
+		if (check_one_root(lp, nparts) == 0 && partman_go == 0)
 			msg_display(MSG_must_be_one_root);
 		else 
 			/* Check for overlaps */
@@ -686,7 +686,7 @@ incorelabel(const char *dkname, partinfo *lp)
 	 * than d_diskname.  Who knows why, but pull the value back here.
 	 */
 	if (lab.d_typename[0] != 0 && strcmp(lab.d_typename, "unknown") != 0)
-		strlcpy(bsddiskname, lab.d_typename, sizeof bsddiskname);
+		strlcpy(pm->bsddiskname, lab.d_typename, sizeof pm->bsddiskname);
 
 	fd = opendisk(dkname, O_RDONLY, buf, sizeof buf, 0);
 	pp = &lab.d_partitions[0];
@@ -806,10 +806,10 @@ getpartoff(uint32_t defpartstart)
 		if (isize[1] == '\0' && isize[0] >= 'a' &&
 		    isize[0] <= maxpartc) {
 			partn = isize[0] - 'a';
-			i = bsdlabel[partn].pi_size + bsdlabel[partn].pi_offset;
+			i = pm->bsdlabel[partn].pi_size + pm->bsdlabel[partn].pi_offset;
 			localsizemult = 1;
 		} else if (atoi(isize) == -1) {
-			i = ptstart;
+			i = pm->ptstart;
 			localsizemult = 1;
 		} else {
 			if (atofsb(isize, &i, &localsizemult)) {
@@ -818,13 +818,13 @@ getpartoff(uint32_t defpartstart)
 			}
 		}
 		/* round to cylinder size if localsizemult != 1 */
-		i = NUMSEC(i/localsizemult, localsizemult, dlcylsize);
+		i = NUMSEC(i/localsizemult, localsizemult, pm->dlcylsize);
 		/* Adjust to start of slice if needed */
-		if ((i < ptstart && (ptstart - i) < localsizemult) ||
-		    (i > ptstart && (i - ptstart) < localsizemult)) {
-			i = ptstart;
+		if ((i < pm->ptstart && (pm->ptstart - i) < localsizemult) ||
+		    (i > pm->ptstart && (i - pm->ptstart) < localsizemult)) {
+			i = pm->ptstart;
 		}
-		if (i <= dlsize)
+		if (i <= pm->dlsize)
 			break;
 		errmsg = msg_string(MSG_startoutsidedisk);
 	}
@@ -839,7 +839,7 @@ getpartsize(uint32_t partstart, uint32_t defpartsize)
 	char dsize[20], isize[20], maxpartc;
 	const char *errmsg = "\n";
 	uint32_t i, partend, localsizemult;
-	uint32_t fsptend = ptstart + ptsize;
+	uint32_t fsptend = pm->ptstart + pm->ptsize;
 	int partn;
 
 	maxpartc = 'a' + getmaxpartitions() - 1;
@@ -853,7 +853,7 @@ getpartsize(uint32_t partstart, uint32_t defpartsize)
 		if (isize[1] == '\0' && isize[0] >= 'a' &&
 		    isize[0] <= maxpartc) {
 			partn = isize[0] - 'a';
-			i = bsdlabel[partn].pi_offset - partstart;
+			i = pm->bsdlabel[partn].pi_offset - partstart;
 			localsizemult = 1;
 		} else if (atoi(isize) == -1) {
 			i = fsptend - partstart;
@@ -869,17 +869,17 @@ getpartsize(uint32_t partstart, uint32_t defpartsize)
 		 * is not 1 sector
 		 */
 		partend = NUMSEC((partstart + i) / localsizemult,
-		    localsizemult, dlcylsize);
+		    localsizemult, pm->dlcylsize);
 		/* Align to end-of-disk or end-of-slice if close enough */
-		if (partend > (dlsize - localsizemult)
-		    && partend < (dlsize + localsizemult))
-			partend = dlsize;
+		if (partend > (pm->dlsize - localsizemult)
+		    && partend < (pm->dlsize + localsizemult))
+			partend = pm->dlsize;
 		if (partend > (fsptend - localsizemult)
 		    && partend < (fsptend + localsizemult))
 			partend = fsptend;
 		/* sanity checks */
-		if (partend > dlsize) {
-			partend = dlsize;
+		if (partend > pm->dlsize) {
+			partend = pm->dlsize;
 			msg_prompt_win(MSG_endoutsidedisk, -1, 13, 70, 6,
 			    NULL, isize, 1,
 			    (partend - partstart) / sizemult, multname);
@@ -922,15 +922,15 @@ atofsb(const char *str, uint32_t *p_val, uint32_t *localsizemult)
 		}
 		if (str[i] == 'G' || str[i] == 'g') {
 			val *= 1024;
-			*localsizemult = MEG / sectorsize;
+			*localsizemult = MEG / pm->sectorsize;
 			break;
 		}
 		if (str[i] == 'M' || str[i] == 'm') {
-			*localsizemult = MEG / sectorsize;
+			*localsizemult = MEG / pm->sectorsize;
 			break;
 		}
 		if (str[i] == 'c') {
-			*localsizemult = dlcylsize;
+			*localsizemult = pm->dlcylsize;
 			break;
 		}
 		if (str[i] == 's') {
